-- SDL_ttf.ew
-- Euphoria bindings fot the SDL_gfx library
-- Written by Mark K. Akita     1/27/04
------------------------------------------------------------
include dll.e
include machine.e
------------------------------------------------------------
global atom sdl_gfx
if platform() = LINUX then
        sdl_gfx=open_dll("libSDL_gfx.so")
else
        sdl_gfx = open_dll("SDL_GFX.dll")
end if
------------------------------------------------------------

global constant CpixelColor=define_c_func(sdl_gfx,"pixelColor",{C_POINTER,C_LONG,C_LONG,C_LONG},C_INT)
global function pixelColor(atom dst,atom x,atom y,atom color)
	return c_func(CpixelColor,{dst,x,y,color})
end function

global constant CpixelRGBA=define_c_func(sdl_gfx,"pixelRGBA",{C_POINTER,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function pixelRGBA(atom dst,atom x,atom y,atom r,atom g,atom b,atom a)
	return c_func(CpixelRGBA,{dst,x,y,r,g,b,a})
end function

global constant ChlineColor=define_c_func(sdl_gfx,"hlineColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function hlineColor(atom dst,atom x1,atom x2,atom y,atom color)
	return c_func(ChlineColor,{dst,x1,x2,y,color})
end function

global constant ChlineRGBA=define_c_func(sdl_gfx,"hlineRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function hlineRGBA(atom dst,atom x1,atom x2,atom y,atom r,atom g,atom b,atom a)
	return c_func(ChlineRGBA,{dst,x1,x2,y,r,g,b,a})
end function

global constant CvlineColor=define_c_func(sdl_gfx,"vlineColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function vlineColor(atom dst,atom x,atom y1,atom y2,atom color)
	return c_func(CvlineColor,{dst,x,y1,y2,color})
end function

global constant CvlineRGBA=define_c_func(sdl_gfx,"vlineRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function vlineRGBA(atom dst,atom x,atom y1,atom y2,atom r,atom g,atom b,atom a)
	return c_func(CvlineRGBA,{dst,x,y1,y2,r,g,b,a})
end function

global constant CrectangleColor=define_c_func(sdl_gfx,"rectangleColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function rectangleColor(atom dst,atom x1,atom y1,atom x2,atom y2,atom color)
	return c_func(CrectangleColor,{dst,x1,y1,x2,y2,color})
end function

global constant CrectangleRGBA=define_c_func(sdl_gfx,"rectangleRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function rectangleRGBA(atom dst,atom x1,atom y1,atom x2,atom y2,atom r,atom g,atom b,atom a)
	return c_func(CrectangleRGBA,{dst,x1,y1,x2,y2,r,g,b,a})
end function

global constant CboxColor=define_c_func(sdl_gfx,"boxColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function boxColor(atom dst,atom x1,atom y1,atom x2,atom y2,atom color)
	return c_func(CboxColor,{dst,x1,y1,x2,y2,color})
end function

global constant CboxRGBA=define_c_func(sdl_gfx,"boxRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function boxRGBA(atom dst,atom x1,atom y1,atom x2,atom y2,atom r,atom g,atom b,atom a)
	return c_func(CboxRGBA,{dst,x1,y1,x2,y2,r,g,b,a})
end function

global constant ClineColor=define_c_func(sdl_gfx,"lineColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function lineColor(atom dst,atom x1,atom y1,atom x2,atom y2,atom color)
	return c_func(ClineColor,{dst,x1,y1,x2,y2,color})
end function

global constant ClineRGBA=define_c_func(sdl_gfx,"lineRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function lineRGBA(atom dst,atom x1,atom y1,atom x2,atom y2,atom r,atom g,atom b,atom a)
	return c_func(ClineRGBA,{dst,x1,y1,x2,y2,r,g,b,a})
end function

global constant CaalineColor=define_c_func(sdl_gfx,"aalineColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function aalineColor(atom dst,atom x1,atom y1,atom x2,atom y2,atom color)
	return c_func(CaalineColor,{dst,x1,y1,x2,y2,color})
end function

global constant CaalineRGBA=define_c_func(sdl_gfx,"aalineRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function aalineRGBA(atom dst,atom x1,atom y1,atom x2,atom y2,atom r,atom g,atom b,atom a)
	return c_func(CaalineRGBA,{dst,x1,y1,x2,y2,r,g,b,a})
end function

global constant CcircleColor=define_c_func(sdl_gfx,"circleColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function circleColor(atom dst,atom x,atom y,atom r,atom color)
	return c_func(CcircleColor,{dst,x,y,r,color})
end function

global constant CcircleRGBA=define_c_func(sdl_gfx,"circleRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function circleRGBA(atom dst,atom x,atom y,atom rad,atom r,atom g,atom b,atom a)
	return c_func(CcircleRGBA,{dst,x,y,rad,r,g,b,a})
end function

global constant CaacircleColor=define_c_func(sdl_gfx,"aacircleColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function aacircleColor(atom dst,atom x,atom y,atom r,atom color)
	return c_func(CaacircleColor,{dst,x,y,r,color})
end function

global constant CaacircleRGBA=define_c_func(sdl_gfx,"aacircleRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function aacircleRGBA(atom dst,atom x,atom y,atom rad,atom r,atom g,atom b,atom a)
	return c_func(CaacircleRGBA,{dst,x,y,rad,r,g,b,a})
end function

global constant CfilledCircleColor=define_c_func(sdl_gfx,"filledCircleColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function filledCircleColor(atom dst,atom x,atom y,atom r,atom color)
	return c_func(CfilledCircleColor,{dst,x,y,r,color})
end function

global constant CfilledCircleRGBA=define_c_func(sdl_gfx,"filledCircleRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function filledCircleRGBA(atom dst,atom x,atom y,atom rad,atom r,atom g,atom b,atom a)
	return c_func(CfilledCircleRGBA,{dst,x,y,rad,r,g,b,a})
end function

global constant CellipseColor=define_c_func(sdl_gfx,"ellipseColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function ellipseColor(atom dst,atom x,atom y,atom rx,atom ry,atom color)
	return c_func(CellipseColor,{dst,x,y,rx,ry,color})
end function

global constant CellipseRGBA=define_c_func(sdl_gfx,"ellipseRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function ellipseRGBA(atom dst,atom x,atom y,atom rx,atom ry,atom r,atom g,atom b,atom a)
	return c_func(CellipseRGBA,{dst,x,y,rx,ry,r,g,b,a})
end function

global constant CaaellipseColor=define_c_func(sdl_gfx,"aaellipseColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function aaellipseColor(atom dst,atom x,atom y,atom rx,atom ry,atom color)
	return c_func(CaaellipseColor,{dst,x,y,rx,ry,color})
end function

global constant CaaellipseRGBA=define_c_func(sdl_gfx,"aaellipseRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function aaellipseRGBA(atom dst,atom x,atom y,atom rx,atom ry,atom r,atom g,atom b,atom a)
	return c_func(CaaellipseRGBA,{dst,x,y,rx,ry,r,g,b,a})
end function

global constant CfilledEllipseColor=define_c_func(sdl_gfx,"filledEllipseColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function filledEllipseColor(atom dst,atom x,atom y,atom rx,atom ry,atom color)
	return c_func(CfilledEllipseColor,{dst,x,y,rx,ry,color})
end function

global constant CfilledEllipseRGBA=define_c_func(sdl_gfx,"filledEllipseRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function filledEllipseRGBA(atom dst,atom x,atom y,atom rx,atom ry,atom r,atom g,atom b,atom a)
	return c_func(CfilledEllipseRGBA,{dst,x,y,rx,ry,r,g,b,a})
end function

global constant CfilledpieColor=define_c_func(sdl_gfx,"filledpieColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function filledpieColor(atom dst,atom x,atom y,atom rad,atom start,atom ends,atom color)
	return c_func(CfilledpieColor,{dst,x,y,rad,start,ends,color})
end function

global constant CfilledpieRGBA=define_c_func(sdl_gfx,"filledpieRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function filledpieRGBA(atom dst,atom x,atom y,atom rad,atom start,atom ends,atom r,atom g,atom b,atom a)
	return c_func(CfilledpieRGBA,{dst,x,y,rad,start,ends,r,g,b,a})
end function

global constant CtrigonColor=define_c_func(sdl_gfx,"trigonColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function trigonColor(atom dst,atom x1,atom y1,atom x2,atom y2,atom x3,atom y3,atom color)
	return c_func(CtrigonColor,{dst,x1,y1,x2,y2,x3,y3,color})
end function

global constant CtrigonRGBA=define_c_func(sdl_gfx,"trigonRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function trigonRGBA(atom dst,atom x1,atom y1,atom x2,atom y2,atom x3,atom y3,atom r,atom g,atom b,atom a)
	return c_func(CtrigonRGBA,{dst,x1,y1,x2,y2,x3,y3,r,g,b,a})
end function

global constant CaatrigonColor=define_c_func(sdl_gfx,"aatrigonColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG},C_INT)
global function aatrigonColor(atom dst,atom x1,atom y1,atom x2,atom y2,atom x3,atom y3,atom color)
	return c_func(CaatrigonColor,{dst,x1,y1,x2,y2,x3,y3,color})
end function

global constant CaatrigonRGBA=define_c_func(sdl_gfx,"aatrigonRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function aatrigonRGBA(atom dst,atom x1,atom y1,atom x2,atom y2,atom x3,atom y3,atom r,atom g,atom b,atom a)
	return c_func(CaatrigonRGBA,{dst,x1,y1,x2,y2,x3,y3,r,g,b,a})
end function

global constant CfilledTrigonColor=define_c_func(sdl_gfx,"filledTrigonColor",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_INT},C_INT)
global function filledTrigonColor(atom dst,atom x1,atom y1,atom x2,atom y2,atom x3,atom y3,atom color)
	return c_func(CfilledTrigonColor,{dst,x1,y1,x2,y2,x3,y3,color})
end function

global constant CfilledTrigonRGBA=define_c_func(sdl_gfx,"filledTrigonRGBA",{C_POINTER,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function filledTrigonRGBA(atom dst,atom x1,atom y1,atom x2,atom y2,atom x3,atom y3,atom r,atom g,atom b,atom a)
	return c_func(CfilledTrigonRGBA,{dst,x1,y1,x2,y2,x3,y3,r,g,b,a})
end function

global constant CpolygonColor=define_c_func(sdl_gfx,"polygonColor",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_LONG},C_INT)
global function polygonColor(atom dst,atom vx,atom vy,atom n,atom color)
	return c_func(CpolygonColor,{dst,vx,vy,n,color})
end function

global constant CpolygonRGBA=define_c_func(sdl_gfx,"polygonRGBA",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function polygonRGBA(atom dst,atom vx,atom vy,atom n,atom r,atom g,atom b,atom a)
	return c_func(CpolygonRGBA,{dst,vx,vy,n,r,g,b,a})
end function

global constant CaapolygonColor=define_c_func(sdl_gfx,"aapolygonColor",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_LONG},C_INT)
global function aapolygonColor(atom dst,atom vx,atom vy,atom n,atom color)
	return c_func(CaapolygonColor,{dst,vx,vy,n,color})
end function

global constant CaapolygonRGBA=define_c_func(sdl_gfx,"aapolygonRGBA",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function aapolygonRGBA(atom dst,atom vx,atom vy,atom n,atom r,atom g,atom b,atom a)
	return c_func(CaapolygonRGBA,{dst,vx,vy,n,r,g,b,a})
end function

global constant CfilledPolygonColor=define_c_func(sdl_gfx,"filledPolygonColor",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_INT},C_INT)
global function filledPolygonColor(atom dst,atom vx,atom vy,atom n,atom color)
	return c_func(CfilledPolygonColor,{dst,vx,vy,n,color})
end function

global constant CfilledPolygonRGBA=define_c_func(sdl_gfx,"filledPolygonRGBA",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function filledPolygonRGBA(atom dst,atom vx,atom vy,atom n,atom r,atom g,atom b,atom a)
	return c_func(CfilledPolygonRGBA,{dst,vx,vy,n,r,g,b,a})
end function

global constant CbezierColor=define_c_func(sdl_gfx,"bezierColor",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_INT,C_LONG},C_INT)
global function bezierColor(atom dst,atom vx,atom vy,atom n,atom s,atom color)
	return c_func(CbezierColor,{dst,vx,vy,n,s,color})
end function

global constant CbezierRGBA=define_c_func(sdl_gfx,"bezierRGBA",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_INT,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function bezierRGBA(atom dst,atom vx,atom vy,atom n,atom s,atom r,atom g,atom b,atom a)
	return c_func(CbezierRGBA,{dst,vx,vy,n,s,r,g,b,a})
end function

global constant CcharacterColor=define_c_func(sdl_gfx,"characterColor",{C_POINTER,C_LONG,C_LONG,C_CHAR,C_LONG},C_INT)
global function characterColor(atom dst,atom x,atom y,atom c,atom color)
	return c_func(CcharacterColor,{dst,x,y,c,color})
end function

global constant CcharacterRGBA=define_c_func(sdl_gfx,"characterRGBA",{C_POINTER,C_LONG,C_LONG,C_CHAR,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function characterRGBA(atom dst,atom x,atom y,atom c,atom r,atom g,atom b,atom a)
	return c_func(CcharacterRGBA,{dst,x,y,c,r,g,b,a})
end function

global constant CstringColor=define_c_func(sdl_gfx,"stringColor",{C_POINTER,C_LONG,C_LONG,C_POINTER,C_LONG},C_INT)
global function stringColor(atom dst,atom x,atom y,sequence c,atom color)
    atom c_adr
    c_adr = allocate_string(c)
	return c_func(CstringColor,{dst,x,y,c_adr,color})
end function

global constant CstringRGBA=define_c_func(sdl_gfx,"stringRGBA",{C_POINTER,C_LONG,C_LONG,C_POINTER,C_CHAR,C_CHAR,C_CHAR,C_CHAR},C_INT)
global function stringRGBA(atom dst,atom x,atom y,sequence c,atom r,atom g,atom b,atom a)
    atom c_adr
    c_adr = allocate_string(c)
	return c_func(CstringRGBA,{dst,x,y,c_adr,r,g,b,a})
end function

global constant CrotozoomSurface=define_c_func(sdl_gfx,"rotozoomSurface",{C_POINTER,C_DOUBLE,C_DOUBLE,C_INT},C_POINTER)
global function rotozoomSurface(atom src,atom angle,atom zoom,atom smooth)
	return c_func(CrotozoomSurface,{src,angle,zoom,smooth})
end function

global constant CzoomSurface=define_c_func(sdl_gfx,"zoomSurface",{C_POINTER,C_DOUBLE,C_DOUBLE,C_INT},C_POINTER)
global function zoomSurface(atom src,atom zoomx,atom zoomy,atom smooth)
	return c_func(CzoomSurface,{src,zoomx,zoomy,smooth})
end function

global constant SMOOTHING_OFF=0
global constant SMOOTHING_ON=1
