-- SDL_ttf.ew
-- Euphoria bindings fot the SDL_ttf library
-- Written by Mark K. Akita     1/22/04
------------------------------------------------------------
--    SDL_ttf:  A companion library to SDL for working with TrueType (tm) fonts
--    Copyright (C) 1997, 1998, 1999, 2000, 2001  Sam Lantinga
--    This library is free software; you can redistribute it and/or
--    modify it under the terms of the GNU Library General Public
--    License as published by the Free Software Foundation; either
--    version 2 of the License, or (at your option) any later version.

--    This library is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
--    Library General Public License for more details.

--    You should have received a copy of the GNU Library General Public
--    License along with this library; if not, write to the Free
--    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

--    Sam Lantinga
--    slouken@libsdl.org
------------------------------------------------------------
include dll.e
include machine.e
------------------------------------------------------------
--constant sdlttf=open_dll("SDL_ttf.dll")
------------------------------------------------------------
global atom sdlttf
if platform() = LINUX then
        sdlttf=open_dll("libSDL_ttf.so")
else
        sdlttf = open_dll("SDL_ttf.dll")
end if

global constant SDLttf_h=0
--unknown typedef struct TTF_Font TTF_Font

global constant CTTF_Init=define_c_func(sdlttf,"TTF_Init",{},C_INT)
global function TTF_Init()
	return c_func(CTTF_Init,{})
end function

global constant CTTF_OpenFont=define_c_func(sdlttf,"TTF_OpenFont",{C_POINTER,C_INT},C_POINTER)
global function TTF_OpenFont(sequence file,atom ptsize)
    atom f_adr
    f_adr = allocate_string(file)
	return c_func(CTTF_OpenFont,{f_adr,ptsize})
end function

global constant CTTF_OpenFontIndex=define_c_func(sdlttf,"TTF_OpenFontIndex",{C_POINTER,C_INT,C_LONG},C_POINTER)
global function TTF_OpenFontIndex(sequence file,atom ptsize,atom index)
    atom f_adr
    f_adr = allocate_string(file)
	return c_func(CTTF_OpenFontIndex,{f_adr,ptsize,index})
end function

global constant TTF_STYLE_NORMAL=0
global constant TTF_STYLE_BOLD=1
global constant TTF_STYLE_ITALIC=2
global constant TTF_STYLE_UNDERLINE=4

global constant CTTF_GetFontStyle=define_c_func(sdlttf,"TTF_GetFontStyle",{C_POINTER},C_INT)
global function TTF_GetFontStyle(object font)
	return c_func(CTTF_GetFontStyle,{font})
end function

global constant CTTF_SetFontStyle=define_c_proc(sdlttf,"TTF_SetFontStyle",{C_POINTER,C_INT})
global procedure TTF_SetFontStyle(object font,atom style)
	c_proc(CTTF_SetFontStyle,{font,style})
end procedure

global constant CTTF_FontHeight=define_c_func(sdlttf,"TTF_FontHeight",{C_POINTER},C_INT)
global function TTF_FontHeight(object font)
	return c_func(CTTF_FontHeight,{font})
end function

global constant CTTF_FontAscent=define_c_func(sdlttf,"TTF_FontAscent",{C_POINTER},C_INT)
global function TTF_FontAscent(object font)
	return c_func(CTTF_FontAscent,{font})
end function

global constant CTTF_FontDescent=define_c_func(sdlttf,"TTF_FontDescent",{C_POINTER},C_INT)
global function TTF_FontDescent(object font)
	return c_func(CTTF_FontDescent,{font})
end function

global constant CTTF_FontLineSkip=define_c_func(sdlttf,"TTF_FontLineSkip",{C_POINTER},C_INT)
global function TTF_FontLineSkip(object font)
	return c_func(CTTF_FontLineSkip,{font})
end function

global constant CTTF_FontFaces=define_c_func(sdlttf,"TTF_FontFaces",{C_POINTER},C_LONG)
global function TTF_FontFaces(object font)
	return c_func(CTTF_FontFaces,{font})
end function

global constant CTTF_FontFaceIsFixedWidth=define_c_func(sdlttf,"TTF_FontFaceIsFixedWidth",{C_POINTER},C_INT)
global function TTF_FontFaceIsFixedWidth(object font)
	return c_func(CTTF_FontFaceIsFixedWidth,{font})
end function

global constant CTTF_FontFaceFamilyName=define_c_func(sdlttf,"TTF_FontFaceFamilyName",{C_POINTER},C_CHAR)
global function TTF_FontFaceFamilyName(object font)
	return c_func(CTTF_FontFaceFamilyName,{font})
end function

global constant CTTF_FontFaceStyleName=define_c_func(sdlttf,"TTF_FontFaceStyleName",{C_POINTER},C_CHAR)
global function TTF_FontFaceStyleName(object font)
	return c_func(CTTF_FontFaceStyleName,{font})
end function

global constant CTTF_GlyphMetrics=define_c_func(sdlttf,"TTF_GlyphMetrics",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_INT},C_INT)
global function TTF_GlyphMetrics(object font,atom minx,atom maxx,atom miny,atom maxy,atom advance)
	return c_func(CTTF_GlyphMetrics,{font,minx,maxx,miny,maxy,advance})
end function

global constant CTTF_SizeText=define_c_func(sdlttf,"TTF_SizeText",{C_POINTER,C_POINTER,C_INT,C_INT},C_INT)
global function TTF_SizeText(object font,sequence text,atom w,atom h)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_SizeText,{font,t_adr,w,h})
end function

global constant CTTF_SizeUTF8=define_c_func(sdlttf,"TTF_SizeUTF8",{C_POINTER,C_POINTER,C_INT,C_INT},C_INT)
global function TTF_SizeUTF8(object font,sequence text,atom w,atom h)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_SizeUTF8,{font,t_adr,w,h})
end function

global constant CTTF_SizeUNICODE=define_c_func(sdlttf,"TTF_SizeUNICODE",{C_POINTER,C_INT,C_INT},C_INT)
global function TTF_SizeUNICODE(object font,atom w,atom h)
	return c_func(CTTF_SizeUNICODE,{font,w,h})
end function

global constant CTTF_RenderText_Solid=define_c_func(sdlttf,"TTF_RenderText_Solid",{C_POINTER,C_POINTER,C_LONG},C_POINTER)
global function TTF_RenderText_Solid(object font,sequence text,atom fg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderText_Solid,{font,t_adr,fg})
end function

global constant CTTF_RenderUTF8_Solid=define_c_func(sdlttf,"TTF_RenderUTF8_Solid",{C_POINTER,C_POINTER,C_LONG},C_POINTER)
global function TTF_RenderUTF8_Solid(object font,sequence text,atom fg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderUTF8_Solid,{font,t_adr,fg})
end function

global constant CTTF_RenderUNICODE_Solid=define_c_func(sdlttf,"TTF_RenderUNICODE_Solid",{C_POINTER,C_POINTER,C_LONG},C_POINTER)
global function TTF_RenderUNICODE_Solid(object font,sequence text,atom fg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderUNICODE_Solid,{font,t_adr,fg})
end function

global constant CTTF_RenderGlyph_Solid=define_c_func(sdlttf,"TTF_RenderGlyph_Solid",{C_POINTER,C_UINT,C_LONG},C_POINTER)
global function TTF_RenderGlyph_Solid(object font,atom ch,atom fg)
	return c_func(CTTF_RenderGlyph_Solid,{font,ch,fg})
end function

global constant CTTF_RenderText_Shaded=define_c_func(sdlttf,"TTF_RenderText_Shaded",{C_POINTER,C_POINTER,C_LONG,C_LONG},C_POINTER)
global function TTF_RenderText_Shaded(object font,sequence text,atom fg,atom bg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderText_Shaded,{font,t_adr,fg,bg})
end function

global constant CTTF_RenderUTF8_Shaded=define_c_func(sdlttf,"TTF_RenderUTF8_Shaded",{C_POINTER,C_POINTER,C_LONG,C_LONG},C_POINTER)
global function TTF_RenderUTF8_Shaded(object font,sequence text,atom fg,atom bg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderUTF8_Shaded,{font,t_adr,fg,bg})
end function

global constant CTTF_RenderUNICODE_Shaded=define_c_func(sdlttf,"TTF_RenderUNICODE_Shaded",{C_POINTER,C_POINTER,C_LONG,C_LONG},C_POINTER)
global function TTF_RenderUNICODE_Shaded(object font,sequence text,atom fg,atom bg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderUNICODE_Shaded,{font,t_adr,fg,bg})
end function

global constant CTTF_RenderGlyph_Shaded=define_c_func(sdlttf,"TTF_RenderGlyph_Shaded",{C_POINTER,C_UINT,C_LONG,C_LONG},C_POINTER)
global function TTF_RenderGlyph_Shaded(object font,atom ch,atom fg,atom bg)
	return c_func(CTTF_RenderGlyph_Shaded,{font,ch,fg,bg})
end function

global constant CTTF_RenderText_Blended=define_c_func(sdlttf,"TTF_RenderText_Blended",{C_POINTER,C_POINTER,C_LONG},C_POINTER)
global function TTF_RenderText_Blended(object font,sequence text,atom fg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderText_Blended,{font,t_adr,fg})
end function

global constant CTTF_RenderUTF8_Blended=define_c_func(sdlttf,"TTF_RenderUTF8_Blended",{C_POINTER,C_POINTER,C_LONG},C_POINTER)
global function TTF_RenderUTF8_Blended(object font,sequence text,atom fg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderUTF8_Blended,{font,t_adr,fg})
end function

global constant CTTF_RenderUNICODE_Blended=define_c_func(sdlttf,"TTF_RenderUNICODE_Blended",{C_POINTER,C_POINTER,C_LONG},C_POINTER)
global function TTF_RenderUNICODE_Blended(object font,sequence text,atom fg)
    atom t_adr
    t_adr = allocate_string(text)
	return c_func(CTTF_RenderUNICODE_Blended,{font,t_adr,fg})
end function

global constant CTTF_RenderGlyph_Blended=define_c_func(sdlttf,"TTF_RenderGlyph_Blended",{C_POINTER,C_UINT,C_LONG},C_POINTER)
global function TTF_RenderGlyph_Blended(object font,atom ch,atom fg)
	return c_func(CTTF_RenderGlyph_Blended,{font,ch,fg})
end function

--global constant TTF_RenderText=0
--global constant TTF_RenderUTF8=0
--global constant TTF_RenderUNICODE=0

global constant CTTF_CloseFont=define_c_proc(sdlttf,"TTF_CloseFont",{C_POINTER})
global procedure TTF_CloseFont(object font)
	c_proc(CTTF_CloseFont,{font})
end procedure

global constant CTTF_Quit=define_c_proc(sdlttf,"TTF_Quit",{})
global procedure TTF_Quit()
	c_proc(CTTF_Quit,{})
end procedure

